%------------------------------------------------------------------------
%----------------	PROGRAMME Software_WP6.m    -------------------------
%------------------------------------------------------------------------

%Software for integrated O3 profiles and partial column (present draft, will be updated and finalized in 1 month)

%------ Software for integrated O3 profiles from LIDAR, FTIR and MW ------
%The Software_WP6 is presently written for the alpine stations

%For these stations, an estimation of biais and a neural network approach is needed
%The other stations will only need a estimation of the bias between
%instrument
%This software run without user interface. It will seek for the latest FTIR MW and LIDAR HDF data
%for each station and will produce the resulting O3 profiles

%----------------------------------------------------------------------------
%----  construction of the software  -----------------------------------------
%-----------------------------------------------------------------------------

%For all the stations
%---------------------
%Read HDF file 
%Looking for the coincident data 
%Comparison between each instrument and applied an estimation of the bias
%Define the weight error for each instruments profiles
%creat the resulting O3 profiles

%Only for Alpine station
%------------------------
%Looking for Altitude levels where OHP and Bern Equivalent latitude present max bias
%Use of the Neural network aproach at each altitude define earlier to obtaine station weight.
%(need the input of the soom_toolbox)
%Add the resulting weight to the resulting O3 profiles define earlier


%---What had to be added in the present software within the next month -----------
%Read file and coincident programme are written in IDL format. It will be converted in matlab on the finalized version
%The define the weight error for each instruments profiles under test
%creation of the resulting profile

%-------------------------------------------------------------------------
%Comparison between each instrument and applied an estimation of the bias
%-------------------------------------------------------------------------

fid = fopen('series_moyenne_lidar_formatter_matlab_vmr.txt')
tline = fgetl(fid);
tline = fgetl(fid);
i = 1;
while tline ~= -1,
    LIDAR(i,:) = sscanf(tline,'%f');
    i=i+1;
    tline=fgetl(fid);
end
fclose(fid);

fid = fopen('series_moyenne_ftir_formatter_matlab_vmrde.txt')
tline = fgetl(fid);
tline = fgetl(fid);
i = 1;
while tline ~= -1,
    FTIR(i,:) = sscanf(tline,'%f');
    i=i+1;
    tline=fgetl(fid);
end
fclose(fid);



fid = fopen('series_moyenne_lidaravk_formatter_matlab_vmr.txt')
tline = fgetl(fid);
tline = fgetl(fid);
i = 1;
while tline ~= -1,
    LIDAR_AVK(i,:) = sscanf(tline,'%f');
    i=i+1;
    tline=fgetl(fid);
end
fclose(fid)

fid = fopen('series_moyenne_micro_formatter_matlab_vmr.txt')
tline = fgetl(fid);
tline = fgetl(fid);
i = 1;
while tline ~= -1,
    MW(i,:) = sscanf(tline,'%f');
    i=i+1;
    tline=fgetl(fid);
end
fclose(fid)


fid = fopen('altitude.txt')
tline = fgetl(fid);
tline = fgetl(fid);
i = 1;
while tline ~= -1,
    altitude(i,:) = sscanf(tline,'%f');
    i=i+1;
    tline=fgetl(fid);
end
fclose(fid);

fid = fopen('date.txt')
tline = fgetl(fid);
tline = fgetl(fid);
i = 1;
while tline ~= -1,
    annee(i,:) = sscanf(tline,'%f');
    i=i+1;
    tline=fgetl(fid);
end
fclose(fid);

%%%%%plot of times series

figure
set(gcf,'position', [103.2000  412.0000  816.0000  176.0000])
pcolor(annee(:,3),altitude',LIDAR)
shading flat;
caxis([0 9])
set(gca, 'xtick', 2003:1:2011)
title('LIDAR ', 'fontsize',14)
h=colorbar
set(get(h,'xlabel'),'String','VMR','fontsize', 14)
set(h,'XAxisLocation', 'top')
set(h,'YAxisLocation', 'right')
set(h,'YAxisLocation', 'left')
set(h,'YAxisLocation', 'right')
set(gca, 'fontsize', 14)
xlim([2003 2012])
ylim([10 60])
ylabel('Altitude (km)', 'fontsize', 14)
 set(gcf, 'Units', 'points')
        set(gcf, 'PaperUnits', 'points')
        size_fig = get(gcf, 'Position');
        size_fig = size_fig(3:4);
        set(gcf, 'PaperSize', size_fig)
        set(gcf, 'PaperPosition', [0, 0, size_fig(1), size_fig(2)])
        print('-depsc', 'lidar_time_serie_new')
        
        
        
        
figure
set(gcf,'position', [103.2000  412.0000  816.0000  176.0000])
pcolor(annee(:,3),altitude',LIDAR_AVK)
shading flat;
caxis([0 9])
set(gca, 'xtick', 2003:1:2011)
title('LIDAR smoothed ', 'fontsize',14)
h=colorbar
set(get(h,'xlabel'),'String','VMR','fontsize', 14)
set(h,'XAxisLocation', 'top')
set(h,'YAxisLocation', 'right')
set(h,'YAxisLocation', 'left')
set(h,'YAxisLocation', 'right')
set(gca, 'fontsize', 14)
xlim([2003 2012])
ylim([10 60])
ylabel('Altitude (km)', 'fontsize', 14)
 set(gcf, 'Units', 'points')
        set(gcf, 'PaperUnits', 'points')
        size_fig = get(gcf, 'Position');
        size_fig = size_fig(3:4);
        set(gcf, 'PaperSize', size_fig)
        set(gcf, 'PaperPosition', [0, 0, size_fig(1), size_fig(2)])
        print('-depsc', 'lidar_avk_time_serie_new')
        
        
        
        figure
set(gcf,'position', [103.2000  412.0000  816.0000  176.0000])
pcolor(annee(:,3),altitude',MW)
shading flat;
caxis([0 9])
set(gca, 'xtick', 2003:1:2011)
title('MW ', 'fontsize',14)
h=colorbar
set(get(h,'xlabel'),'String','VMR','fontsize', 14)
set(h,'XAxisLocation', 'top')
set(h,'YAxisLocation', 'right')
set(h,'YAxisLocation', 'left')
set(h,'YAxisLocation', 'right')
set(gca, 'fontsize', 14)
xlim([2003 2012])
ylim([10 60])
ylabel('Altitude (km)', 'fontsize', 14)
 set(gcf, 'Units', 'points')
        set(gcf, 'PaperUnits', 'points')
        size_fig = get(gcf, 'Position');
        size_fig = size_fig(3:4);
        set(gcf, 'PaperSize', size_fig)
        set(gcf, 'PaperPosition', [0, 0, size_fig(1), size_fig(2)])
        print('-depsc', 'MW_time_serie_new')
        
        
        figure
set(gcf,'position', [103.2000  412.0000  816.0000  176.0000])
pcolor(annee(:,3),altitude',FTIR)
shading flat;
caxis([0 9])
set(gca, 'xtick', 2003:1:2011)
title('FTIR ', 'fontsize',14)
h=colorbar
set(get(h,'xlabel'),'String','VMR','fontsize', 14)
set(h,'XAxisLocation', 'top')
set(h,'YAxisLocation', 'right')
set(h,'YAxisLocation', 'left')
set(h,'YAxisLocation', 'right')
set(gca, 'fontsize', 14)
xlim([2003 2012])
ylim([10 60])
ylabel('Altitude (km)', 'fontsize', 14)
 set(gcf, 'Units', 'points')
        set(gcf, 'PaperUnits', 'points')
        size_fig = get(gcf, 'Position');
        size_fig = size_fig(3:4);
        set(gcf, 'PaperSize', size_fig)
        set(gcf, 'PaperPosition', [0, 0, size_fig(1), size_fig(2)])
        print('-depsc', 'FTIR_time_serie_new')       
        
        
        
 %%%%%plots of difference monthly means

figure
set(gcf,'position', [103.2000  412.0000  816.0000  176.0000])
pcolor(annee(:,3),altitude',((LIDAR-MW)./MW)*100)
shading flat;
caxis([-40 40])
set(gca, 'xtick', 2003:1:2011)
title('(LIDAR-MW)/MW ', 'fontsize',14)
load my_colorbar
colormap(my_colorbar)
%h=colorbar
%set(get(h,'xlabel'),'String','VMR','fontsize', 12)
%set(h,'XAxisLocation', 'top')
%set(h,'YAxisLocation', 'right')
%set(h,'YAxisLocation', 'left')
%set(h,'YAxisLocation', 'right')
%set(gca, 'fontsize', 12)
xlim([2003 2012])
ylabel('Altitude (km)', 'fontsize', 14)
 set(gcf, 'Units', 'points')
        set(gcf, 'PaperUnits', 'points')
        size_fig = get(gcf, 'Position');
        size_fig = size_fig(3:4);
        set(gcf, 'PaperSize', size_fig)
        set(gcf, 'PaperPosition', [0, 0, size_fig(1), size_fig(2)])
        print('-depsc', 'diff_lidar_MW_time_serie_new')
        
  
figure
set(gcf,'position', [103.2000  412.0000  816.0000  176.0000])
pcolor(annee(:,3),altitude',((LIDAR_AVK-MW)./MW)*100)
shading flat;
caxis([-40 40])
set(gca, 'xtick', 2003:1:2011)
title('(LIDAR_smmothed -MW)/MW ', 'fontsize',14)
load my_colorbar
colormap(my_colorbar)
%h=colorbar
%set(get(h,'xlabel'),'String','VMR','fontsize', 12)
%set(h,'XAxisLocation', 'top')
%set(h,'YAxisLocation', 'right')
%set(h,'YAxisLocation', 'left')
%set(h,'YAxisLocation', 'right')
%set(gca, 'fontsize', 12)
xlim([2003 2011])
ylabel('Altitude (km)', 'fontsize', 14)
 set(gcf, 'Units', 'points')
        set(gcf, 'PaperUnits', 'points')
        size_fig = get(gcf, 'Position');
        size_fig = size_fig(3:4);
        set(gcf, 'PaperSize', size_fig)
        set(gcf, 'PaperPosition', [0, 0, size_fig(1), size_fig(2)])
        print('-depsc', 'diff_lidar_avk_MW_time_serie_new')
      
        
        
 figure
set(gcf,'position', [103.2000  412.0000  816.0000  176.0000])
pcolor(annee(:,3),altitude',((FTIR-MW)./MW)*100)
shading flat;
caxis([-40 40])
set(gca, 'xtick', 2003:1:2011)
title('(FTIR -MW)/MW ', 'fontsize',14)
load my_colorbar
colormap(my_colorbar)
%h=colorbar
%set(get(h,'xlabel'),'String','VMR','fontsize', 12)
%set(h,'XAxisLocation', 'top')
%set(h,'YAxisLocation', 'right')
%set(h,'YAxisLocation', 'left')
%set(h,'YAxisLocation', 'right')
%set(gca, 'fontsize', 12)
xlim([2003 2011])
ylabel('Altitude (km)', 'fontsize', 14)
 set(gcf, 'Units', 'points')
        set(gcf, 'PaperUnits', 'points')
        size_fig = get(gcf, 'Position');
        size_fig = size_fig(3:4);
        set(gcf, 'PaperSize', size_fig)
        set(gcf, 'PaperPosition', [0, 0, size_fig(1), size_fig(2)])
        print('-depsc', 'diff_FTIR_MW_time_serie_new')       
        
        
        
 %---------- study of partial columns ----------------------
 %----------------------------------------------------------
altitude_range = [10 18; 18  28 ; 28 44; 44 60 ]
 
for i = 1:size(altitude_range,1), 
    
    NEW_LIDAR(i,:) = nanmean(LIDAR(find(altitude>=altitude_range(i,1) & altitude<=altitude_range(i,2)),:),1);
    NEW_LIDAR_AVK(i,:) = nanmean(LIDAR_AVK(find(altitude>=altitude_range(i,1) & altitude<=altitude_range(i,2)),:),1);
    NEW_micro(i,:) = nanmean(MW(find(altitude>=altitude_range(i,1) & altitude<=altitude_range(i,2)),:),1);
    NEW_FTIR(i,:) = nanmean(FTIR(find(altitude>=altitude_range(i,1) & altitude<=altitude_range(i,2)),:),1);
    
    REL_DIFF_MW_LIDAR(i,:) = 100 .* ((NEW_LIDAR(i,:)-NEW_micro(i,:) ) ./ NEW_micro(i,:));
    REL_DIFF_MW_FTIR(i,:) = 100 .* ((NEW_FTIR(i,:)-NEW_micro(i,:) ) ./ NEW_micro(i,:));
    REL_DIFF_MLS_LIDAR_avk(i,:) = 100 .* ((NEW_LIDAR_AVK(i,:)-NEW_micro(i,:) ) ./ NEW_micro(i,:)); 
    
    
end       
 
%%%% plot of monthly mean times series

Position_Subplot_Table = [0.13 0.667924528301887 0.383541666666667 0.257075471698113; ... %position subplot 1
    0.513541666666667 0.667924528301887 0.383333333333333 0.257075471698113; ... %position subplot 2
    0.13 0.411320754716981 0.383541666666667 0.25692448665084; ... %position subplot 3
    0.513541666666667 0.411320754716981 0.383333333333333 0.256603773584906; ... %position subplot 4
    0.13 0.154716981132076 0.383541666666667 0.256867369589346; ... %position subplot 5
    0.513570075757576 0.154716981132075 0.383304924242424 0.256867369589346]; %position subplot 6

%% Position des textbox en bas  gauche des subplot
Position_Textbox_Table = [0.12898384966376 0.684026036149929 0.0671875 0.0221238938053097; ... %position subplot 1
    0.514949267531196 0.683536975660869 0.0671875 0.0221238938053097; ... %position subplot 2
    0.129877221421685 0.428607760731654 0.0671875 0.0221238938053097; ... %position subplot 3
    0.51440171709892 0.430692702816597 0.0671875 0.0221238938053097; ... %position subplot 4
    0.131491054274712 0.170615482739376 0.0671875 0.0221238938053097; ... %position subplot 5
    0.515295088856848 0.172821840040074 0.0671875 0.0221238938053097]; %position subplot 6

%% Dfinition des couleurs [R G B]
Color_Table.MLS = [0.600000023841858 0.400000005960464 0]; %MLS
Color_Table.SAGE = [0.847058832645416 0.160784319043159 0]; %SAGE
Color_Table.GOMOS = [1 0.400000005960464 1]; %GOMOS
Color_Table.GOZCARDS = [0 0 0]; %GOZCARDS
Color_Table.ODIN = [0.0431372560560703 0.517647087574005 0.780392169952393];% ODIN
Color_Table.MIPAS = [1 0.8 0];% MIPAS


scrsz = get(0, 'ScreenSize');
figure1 = figure('Position', [1 1 scrsz(3) scrsz(4)]);
%annotation(figure1,'textbox',...
    %[0.375639769452449 0.917522729038775 0.344821325648416 0.058226768968457],...
    %'String',{'Haute-Provence Observatory (44N, 6E)'},...
    %'HorizontalAlignment','center',...
    %'FitBoxToText','off',...
    %'LineStyle','none',...
    %'FontName','Times',...
    %'FontSize',18);

for i = 1:size(altitude_range, 1),
    i
    h = subplot(2, 2, i);
    set(h, 'FontSize', 12, 'FontName', 'Times')
    switch i
        case {2}
            set(h, 'YTickLabel', ' ')
            set(h, 'XTickLabel', ' ')
            legend ('LIDAR', 'LIDAR smoothed')
           case {4}
            set(h, 'YTickLabel', ' ')
            %legend ('LIDAR', 'LIDAR smoothed') 
        case {1}
            set(h, 'XTickLabel', ' ')
        case 3
            ylabel(' O3 Relative Difference [%]', 'FontSize', 16)
            %set(h, 'XTickLabel', ' ')
        case 6
            set(h, 'YTickLabel', ' ')
    end
    hold on
    set(h, 'Position', Position_Subplot_Table(i,:))
    box on;
    ylim([-40 40])
    set(h, 'YTick', -40:10:40)
    xlim([2003 2012])
    set(h, 'XTick', 2003:2:2012)
    plot(annee(:,3),  REL_DIFF_MW_LIDAR(i,:), 'LineStyle', '-', 'LineWidth', 1, 'Marker', '.', 'Color', Color_Table.GOMOS)
    plot(annee(:,3), REL_DIFF_MLS_LIDAR_avk(i,:), 'LineStyle', '-', 'LineWidth', 1, 'Marker', '.', 'Color', Color_Table.SAGE)
    plot(annee(:,3), REL_DIFF_MW_FTIR(i,:), 'LineStyle', '-', 'LineWidth', 1, 'Marker', '.', 'Color', Color_Table.MLS)
    
  if i==2,
      legend1 =  legend ('LIDAR', 'LIDAR smoothed', 'FTIR');
set(legend1,'Position',[0.90730741540677 0.524534161490682 0.0788336933045356 0.145962732919255]);
  end
  
      plot([2003 2012], [0 0], 'k', 'LineStyle', '-', 'LineWidth', 1.2)
    for j = 2003:1:2012,
        plot([j j], [-40 40], 'k', 'LineStyle', '--', 'LineWidth', 0.5)
    end
    
    annotation(figure1,'textbox',...
        Position_Textbox_Table(i,:),...
        'String',{strcat(num2str(altitude_range(i,1)),' - ',num2str(altitude_range(i,2)),' km')},...
        'HorizontalAlignment','center',...
        'FontWeight','bold',...
        'FitBoxToText','off',...
        'LineStyle','none');
 
    
end 
    
    
    
    scrsz = get(0, 'ScreenSize');
figure1 = figure('Position', [1 1 scrsz(3) scrsz(4)]);
%annotation(figure1,'textbox',...
    %[0.375639769452449 0.917522729038775 0.344821325648416 0.058226768968457],...
    %'String',{'Haute-Provence Observatory (44N, 6E)'},...
    %'HorizontalAlignment','center',...
    %'FitBoxToText','off',...
    %'LineStyle','none',...
    %'FontName','Times',...
    %'FontSize',18);

for i = 1:size(altitude_range, 1),

    h = subplot(2, 2, i);
    set(h, 'FontSize', 12, 'FontName', 'Times')
    switch i
        case {2}
            set(h, 'YTickLabel', ' ')
            set(h, 'XTickLabel', ' ')
            legend ('LIDAR', 'LIDAR smoothed')
           case {4}
            set(h, 'YTickLabel', ' ')
            %legend ('LIDAR', 'LIDAR smoothed') 
        case {1}
            set(h, 'XTickLabel', ' ')
        case 3
            ylabel(' O3 Relative Difference [%]', 'FontSize', 16)
            %set(h, 'XTickLabel', ' ')
        case 6
            set(h, 'YTickLabel', ' ')
    end
    hold on
    set(h, 'Position', Position_Subplot_Table(i,:))
    box on;
    ylim([0 9])
    set(h, 'YTick', 0:1:9)
    xlim([2003 2012])
    set(h, 'XTick', 2003:2:2012)
    plot(annee(:,3),  NEW_LIDAR(i,:), 'LineStyle', '-', 'LineWidth', 1, 'Marker', '.', 'Color', Color_Table.GOMOS)
    plot(annee(:,3), NEW_LIDAR_AVK(i,:), 'LineStyle', '-', 'LineWidth', 1, 'Marker', '.', 'Color', Color_Table.SAGE)
    plot(annee(:,3), NEW_micro(i,:), 'LineStyle', '-', 'LineWidth', 1, 'Marker', '.', 'Color', Color_Table.ODIN)
    plot(annee(:,3), NEW_FTIR(i,:), 'LineStyle', '-', 'LineWidth', 1, 'Marker', '.', 'Color', Color_Table.MLS)
  if i==2,
      legend1 =  legend ('LIDAR', 'LIDAR smoothed', 'MW', 'FTIR');
set(legend1,'Position',[0.90730741540677 0.524534161490682 0.0788336933045356 0.145962732919255]);
  end
  
     % plot([2003 2012], [0 0], 'k', 'LineStyle', '-', 'LineWidth', 1.2)
    for j = 2003:1:2012,
        plot([j j], [0 9], 'k', 'LineStyle', '--', 'LineWidth', 0.5)
    end
    
    annotation(figure1,'textbox',...
        Position_Textbox_Table(i,:),...
        'String',{strcat(num2str(altitude_range(i,1)),' - ',num2str(altitude_range(i,2)),' km')},...
        'HorizontalAlignment','center',...
        'FontWeight','bold',...
        'FitBoxToText','off',...
        'LineStyle','none');
    
    
    
    
end

%%%% definition of Altitude level where the equivalent latitude present a stronger standart deviation 
%-----------------------------------------------------------------------------------------------------
fid = fopen('latitude_equivalent_above_station.txt')
tline = fgetl(fid);
tline = fgetl(fid);
i = 1;
while tline ~= -1,
    DataTR(i,:) = sscanf(tline,'%f');
    i=i+1;
    tline=fgetl(fid);
end
fclose(fid);

altitudelevels=['325'; '350'; '375'; '400'; ...
             '425'; '450'; '475'; '500'; ...
             '525';'550'; '575'; '600'; '625'; ... 
             '650'; '675';'700';'725'; ...
            '750';'775'; '800'; '825'; ...
             '850'; '875'; '900'; ...
             '925';'950'];

m=mean(DataTR');
stdr = std(DataTR');
sr = (DataTR'-repmat(m,size(DataTR,2),1));

S=sr'*sr/size(sr,1);
[U VAP] = eig(S);

figure
h=bar(U(:,1),str2num(altitudelevels))
set(get(h(1),'BaseLine'),'LineWidth',1,'LineStyle',':')
y=find(U<U/3)
altitude=altitudelevels(i,1)

%%%%Neural network approach
%%upload of the equivalent latitude data over the define grid ( LAT et LON)
for i=0:lenght(altitude)
fid = fopen('latitude_eqiuivalent_',altitude(i),'.txt')
tline = fgetl(fid);
tline = fgetl(fid);
i = 1;
while tline ~= -1,
    data(i,:) = sscanf(tline,'%f');
    i=i+1;
    tline=fgetl(fid);
end
fclose(fid);
%%%Neural network approach
varnames= {{'LAT'},{'LON'},{'EQUIVALENT LAT'}};
sData = som_data_struct(data,'name','europe','comp_names',varnames);
sData=som_normalize(sData,'var'); %% on met la variance a 1
sMap = som_randinit(sData,'msize',[13 13],'lattice','hexa','shape','sheet');
figure;
sM  = som_seqtrain(sMap,sData,'radius_ini',3,'tracking',3,'trainlen',5000,'neigh','cutgauss'); %5000
figure;
sM  = som_batchtrain(sM,sData,'radius_fin',0.1,'tracking',3,'trainlen',5000,'neigh','cutgauss');%5000
figure;
som_show(sM)

figure;
som_show(sMap)
%%%Estimation of the weight for each station
Bmus = som_bmus(sM, station_location, mask)
distance(x,y) = (x-y)' diag(mask) (x-y)

end



